#define DREAL
#include "atlas_misc.h"
void ATL_dupKBmm8_8_1_b1
   (const int M, const int N, const int K, const double alpha,
    const double *A, const int lda, const double *B, const int ldb,
    const double beta, double *C, const int ldc);
void ATL_dupKBmm16_8_1_b1
   (const int M, const int N, const int K, const double alpha,
    const double *A, const int lda, const double *B, const int ldb,
    const double beta, double *C, const int ldc);
void ATL_dupKBmm24_8_1_b1
   (const int M, const int N, const int K, const double alpha,
    const double *A, const int lda, const double *B, const int ldb,
    const double beta, double *C, const int ldc);
void ATL_dupKBmm32_8_1_b1
   (const int M, const int N, const int K, const double alpha,
    const double *A, const int lda, const double *B, const int ldb,
    const double beta, double *C, const int ldc);
void ATL_dupKBmm40_8_1_b1
   (const int M, const int N, const int K, const double alpha,
    const double *A, const int lda, const double *B, const int ldb,
    const double beta, double *C, const int ldc);
void ATL_dupKBmm48_8_1_b1
   (const int M, const int N, const int K, const double alpha,
    const double *A, const int lda, const double *B, const int ldb,
    const double beta, double *C, const int ldc);
void ATL_dupKBmm56_8_1_b1
   (const int M, const int N, const int K, const double alpha,
    const double *A, const int lda, const double *B, const int ldb,
    const double beta, double *C, const int ldc);
void ATL_dupKBmm64_8_1_b1
   (const int M, const int N, const int K, const double alpha,
    const double *A, const int lda, const double *B, const int ldb,
    const double beta, double *C, const int ldc);
void ATL_dupKBmm72_8_1_b1
   (const int M, const int N, const int K, const double alpha,
    const double *A, const int lda, const double *B, const int ldb,
    const double beta, double *C, const int ldc);
void ATL_dupKBmm80_8_1_b1
   (const int M, const int N, const int K, const double alpha,
    const double *A, const int lda, const double *B, const int ldb,
    const double beta, double *C, const int ldc);
void ATL_dupKBmm88_8_1_b1
   (const int M, const int N, const int K, const double alpha,
    const double *A, const int lda, const double *B, const int ldb,
    const double beta, double *C, const int ldc);
void ATL_dupKBmm96_8_1_b1
   (const int M, const int N, const int K, const double alpha,
    const double *A, const int lda, const double *B, const int ldb,
    const double beta, double *C, const int ldc);
void ATL_dupKBmm104_8_1_b1
   (const int M, const int N, const int K, const double alpha,
    const double *A, const int lda, const double *B, const int ldb,
    const double beta, double *C, const int ldc);
void ATL_dupKBmm112_8_1_b1
   (const int M, const int N, const int K, const double alpha,
    const double *A, const int lda, const double *B, const int ldb,
    const double beta, double *C, const int ldc);
void ATL_dupKBmm120_8_1_b1
   (const int M, const int N, const int K, const double alpha,
    const double *A, const int lda, const double *B, const int ldb,
    const double beta, double *C, const int ldc);
void ATL_dupKBmm128_8_1_b1
   (const int M, const int N, const int K, const double alpha,
    const double *A, const int lda, const double *B, const int ldb,
    const double beta, double *C, const int ldc);
void ATL_dupKBmm136_8_1_b1
   (const int M, const int N, const int K, const double alpha,
    const double *A, const int lda, const double *B, const int ldb,
    const double beta, double *C, const int ldc);
void ATL_dupKBmm144_8_1_b1
   (const int M, const int N, const int K, const double alpha,
    const double *A, const int lda, const double *B, const int ldb,
    const double beta, double *C, const int ldc);
void ATL_dupKBmm152_8_1_b1
   (const int M, const int N, const int K, const double alpha,
    const double *A, const int lda, const double *B, const int ldb,
    const double beta, double *C, const int ldc);
void ATL_dupKBmm160_8_1_b1
   (const int M, const int N, const int K, const double alpha,
    const double *A, const int lda, const double *B, const int ldb,
    const double beta, double *C, const int ldc);
void ATL_dpKBmm_b1
   (const int M, const int N, const int K, const double alpha,
    const double *A, const int lda, const double *B, const int ldb,
    const double beta, double *C, const int ldc);
void ATL_dgpKBmm
   (const int M, const int N, const int K, const double alpha,
    const double *A, const int lda, const double *B, const int ldb,
    const double beta, double *C, const int ldc);
#include "dmm.h"

typedef void (*MMfunc)(const int, const int, const int, const TYPE,
                       const TYPE *, const int, const TYPE *, const int,
                       const TYPE, TYPE *, const int);

void ATL_dpKBmm_b1
   (const int M, const int N, const int K, const TYPE alpha,
    const TYPE *A, const int lda, const TYPE *B, const int ldb,
    const TYPE beta, TYPE *C, const int ldc)
{

   static MMfunc mmfunc[168] = 
   {
      NULL,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dupKBmm8_8_1_b1,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dupKBmm16_8_1_b1,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dupKBmm24_8_1_b1,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dupKBmm32_8_1_b1,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dupKBmm40_8_1_b1,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dupKBmm48_8_1_b1,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dupKBmm56_8_1_b1,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dupKBmm64_8_1_b1,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dupKBmm72_8_1_b1,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dupKBmm80_8_1_b1,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dupKBmm88_8_1_b1,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dupKBmm96_8_1_b1,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dupKBmm104_8_1_b1,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dupKBmm112_8_1_b1,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dupKBmm120_8_1_b1,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dupKBmm128_8_1_b1,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dupKBmm136_8_1_b1,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dupKBmm144_8_1_b1,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dupKBmm152_8_1_b1,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dupKBmm160_8_1_b1,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dgpKBmm,
      ATL_dgpKBmm
   };

   mmfunc[K](M, N, K, alpha, A, lda, B, ldb, beta, C, ldc);
}
void ATL_dpKBmm_b0
   (const int M, const int N, const int K, const TYPE alpha,
    const TYPE *A, const int lda, const TYPE *B, const int ldb,
    const TYPE beta, TYPE *C, const int ldc);
void ATL_dpKBmm_bX
   (const int M, const int N, const int K, const TYPE alpha,
    const TYPE *A, const int lda, const TYPE *B, const int ldb,
    const TYPE beta, TYPE *C, const int ldc);

void ATL_dpKBmm
   (const int M, const int N, const int K, const TYPE alpha,
    const TYPE *A, const int lda, const TYPE *B, const int ldb,
    const TYPE beta, TYPE *C, const int ldc)
{
   if (M != NB || N != NB)
      ATL_dgpKBmm(M, N, K, alpha, A, lda, B, ldb, beta, C, ldc);
   else if (beta == ATL_rone)
      ATL_dpKBmm_b1(M, N, K, alpha, A, lda, B, ldb, beta, C, ldc);
   else if (beta == ATL_rzero)
      ATL_dpKBmm_b0(M, N, K, alpha, A, lda, B, ldb, beta, C, ldc);
   else
      ATL_dpKBmm_bX(M, N, K, alpha, A, lda, B, ldb, beta, C, ldc);
}
