#define SREAL
#include "atlas_misc.h"
void ATL_supKBmm16_16_1_bX
   (const int M, const int N, const int K, const float alpha,
    const float *A, const int lda, const float *B, const int ldb,
    const float beta, float *C, const int ldc);
void ATL_supKBmm32_16_1_bX
   (const int M, const int N, const int K, const float alpha,
    const float *A, const int lda, const float *B, const int ldb,
    const float beta, float *C, const int ldc);
void ATL_supKBmm48_16_1_bX
   (const int M, const int N, const int K, const float alpha,
    const float *A, const int lda, const float *B, const int ldb,
    const float beta, float *C, const int ldc);
void ATL_supKBmm64_16_1_bX
   (const int M, const int N, const int K, const float alpha,
    const float *A, const int lda, const float *B, const int ldb,
    const float beta, float *C, const int ldc);
void ATL_spKBmm_bX
   (const int M, const int N, const int K, const float alpha,
    const float *A, const int lda, const float *B, const int ldb,
    const float beta, float *C, const int ldc);
void ATL_sgpKBmm
   (const int M, const int N, const int K, const float alpha,
    const float *A, const int lda, const float *B, const int ldb,
    const float beta, float *C, const int ldc);

typedef void (*MMfunc)(const int, const int, const int, const TYPE,
                       const TYPE *, const int, const TYPE *, const int,
                       const TYPE, TYPE *, const int);

void ATL_spKBmm_bX
   (const int M, const int N, const int K, const TYPE alpha,
    const TYPE *A, const int lda, const TYPE *B, const int ldb,
    const TYPE beta, TYPE *C, const int ldc)
{

   static MMfunc mmfunc[80] = 
   {
      NULL,
      ATL_sgpKBmm,
      ATL_sgpKBmm,
      ATL_sgpKBmm,
      ATL_sgpKBmm,
      ATL_sgpKBmm,
      ATL_sgpKBmm,
      ATL_sgpKBmm,
      ATL_sgpKBmm,
      ATL_sgpKBmm,
      ATL_sgpKBmm,
      ATL_sgpKBmm,
      ATL_sgpKBmm,
      ATL_sgpKBmm,
      ATL_sgpKBmm,
      ATL_sgpKBmm,
      ATL_supKBmm16_16_1_bX,
      ATL_sgpKBmm,
      ATL_sgpKBmm,
      ATL_sgpKBmm,
      ATL_sgpKBmm,
      ATL_sgpKBmm,
      ATL_sgpKBmm,
      ATL_sgpKBmm,
      ATL_sgpKBmm,
      ATL_sgpKBmm,
      ATL_sgpKBmm,
      ATL_sgpKBmm,
      ATL_sgpKBmm,
      ATL_sgpKBmm,
      ATL_sgpKBmm,
      ATL_sgpKBmm,
      ATL_supKBmm32_16_1_bX,
      ATL_sgpKBmm,
      ATL_sgpKBmm,
      ATL_sgpKBmm,
      ATL_sgpKBmm,
      ATL_sgpKBmm,
      ATL_sgpKBmm,
      ATL_sgpKBmm,
      ATL_sgpKBmm,
      ATL_sgpKBmm,
      ATL_sgpKBmm,
      ATL_sgpKBmm,
      ATL_sgpKBmm,
      ATL_sgpKBmm,
      ATL_sgpKBmm,
      ATL_sgpKBmm,
      ATL_supKBmm48_16_1_bX,
      ATL_sgpKBmm,
      ATL_sgpKBmm,
      ATL_sgpKBmm,
      ATL_sgpKBmm,
      ATL_sgpKBmm,
      ATL_sgpKBmm,
      ATL_sgpKBmm,
      ATL_sgpKBmm,
      ATL_sgpKBmm,
      ATL_sgpKBmm,
      ATL_sgpKBmm,
      ATL_sgpKBmm,
      ATL_sgpKBmm,
      ATL_sgpKBmm,
      ATL_sgpKBmm,
      ATL_supKBmm64_16_1_bX,
      ATL_sgpKBmm,
      ATL_sgpKBmm,
      ATL_sgpKBmm,
      ATL_sgpKBmm,
      ATL_sgpKBmm,
      ATL_sgpKBmm,
      ATL_sgpKBmm,
      ATL_sgpKBmm,
      ATL_sgpKBmm,
      ATL_sgpKBmm,
      ATL_sgpKBmm,
      ATL_sgpKBmm,
      ATL_sgpKBmm,
      ATL_sgpKBmm,
      ATL_sgpKBmm
   };

   mmfunc[K](M, N, K, alpha, A, lda, B, ldb, beta, C, ldc);
}
